window.famobi = window.famobi || {};
window.famobi.hasGameReadyCalled = false;
window.famobi.hideSplashScreen = function() {
	if(!window.famobi.hasGameReadyCalled) {
		window.famobi.hasGameReadyCalled = true;
		console.log("GAMESNACKS.gameReady")
		GAMESNACKS.gameReady();
	}
}
window.famobi.audio = window.famobi.audio || {

	controls: false,
	bgm: true,
	sfx: true,

	init: function() {
		// do something
	},
	hasControls: function() {
		return this.controls;
	},
	isEnabled: function(type) {
		switch(type) {
			case "bgm":
				// return this.bgm;
			case "sfx":
				// return this.sfx;
			default:
				// return this.bgm && this.sfx;
				return GAMESNACKS.isAudioEnabled();
		}
	}
};

window.famobi_analytics = window.famobi_analytics || {};
window.famobi_tracking = window.famobi_tracking || {
	log: function() {},
	initUser: function() {},
	init: function() {},
	trackingAdCallback: function() {},
	trackEvent: function() {},
	sendRequest: function() {},
	processQueue: function() {}
};

window.famobi.getCurrentLanguage = function() {
	return "en";
};

window.famobi_analytics.trackEvent = function(event, params) {
	console.log(event, params);
	return new Promise(function(resolve, reject) {
		switch(event) {
			case "EVENT_LIVESCORE":
				console.log("GAMESNACKS.sendScore", params.liveScore);
				GAMESNACKS.sendScore(params.liveScore);
				return resolve(event, params);
			case "EVENT_LEVELSCORE":
				console.log("GAMESNACKS.sendScore", params.levelScore);
				GAMESNACKS.sendScore(params.levelScore);
				return resolve(event, params);
			case "EVENT_TOTALSCORE":
				console.log("GAMESNACKS.sendScore", params.totalScore);
				GAMESNACKS.sendScore(params.totalScore);

				if(params.totalScore == 0) {
					console.log("GAMESNACKS.gameOver");
					GAMESNACKS.gameOver();
				}
				return resolve(event, params);
			case "EVENT_LEVELFAIL":

				if(params.reason == "quit") {
					console.log("GAMESNACKS.gameOver");
					GAMESNACKS.gameOver();
					break;
				}

				/*
				if(params.reason == "dead") {
					console.log("GAMESNACKS.gameOver");
					GAMESNACKS.gameOver();
				}

				if(params.reason == "timeout") {
					console.log("GAMESNACKS.gameOver");
					GAMESNACKS.gameOver();
				}
				*/
				return resolve(event, params);
			case "EVENT_CUSTOM":

				switch(params.eventName) {
					case "EVENT_LEVELSUCCESS":
						console.log("GAMESNACKS.levelComplete", parseInt(params.levelName));
						GAMESNACKS.levelComplete(parseInt(params.levelName));
						break;
					case "EVENT_LEVELFAIL":
						console.log("GAMESNACKS.gameOver");
						GAMESNACKS.gameOver();
						break;
					default:
						// ...
				}
				break;
			default:
				// ...
		}
		return resolve(event, params);
	});
};

window.famobi_analytics.trackScreen = function(screen) {
	//console.log(screen);
	if(screen == "SCREEN_HOME" || screen == "SCREEN_SHOP" || screen == "SCREEN_LEVEL") {
		setTimeout(function() {
			window.famobi.hideSplashScreen();
		}, 250);
	}
}

// Gamesnack Audio Listener
GAMESNACKS.subscribeToAudioUpdates((isAudioEnabled) => {
	console.log("audio update received!");

	if(isAudioEnabled) {
		if(typeof window.famobi_onUnmuteRequested == "function") {
			window.famobi_onUnmuteRequested();
			console.log("unmuting requested");
		}
	} else {
		if(typeof window.famobi_onMuteRequested == "function") {
			window.famobi_onMuteRequested();
			console.log("muting requested");
		}
	}
});

// localforage: driver to localstorage
if(famobi_gameJS.includes("c2runtime.js")) {

	localForageCheck = setInterval(function() {

		if(typeof localforage !== "undefined") {
			console.log("localforage found");
			clearInterval(localForageCheck);

			localforage.ready(function() {
				localforage.setDriver(localforage.LOCALSTORAGE);
			});
		}
	}, 250);
}
